;;;--------------------------------------------------------------------;;;
;;;             " "               ;;;
;;;                     Rough.lsp Version 2.3                          ;;;
;;;                  AutoCAD R14 for Windows                        ;;;
;;;                          25.02.00                                  ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;

;;
;;         :
;;         " "
;;                Rough
;;

;;=====================================================;;
;;                                           ;;
;;                                                     ;;
;;    "" ,   ;;
;;    CELWEIGHT.      ;;
;; ,          ;;
;;    AutoCAD  2000 (15),   - ;;
;;  CELWEIGHT,      AutoCAD ;;
;;  2000 (15) .   ,  - ;;
;;     AutoCAD 2000 (15)   ;;
;;       CELWEIGHT    - ;;
;;  (";")   .                        ;;
;;=====================================================;;


;=============================================================
;;;     
(setq Rough 1)

;=============================================================
;;;   Rough.shx
(setq old_fdia (getvar "FILEDIA"))
(setvar "FILEDIA" 0)
(command "_load" "Rough")
(setvar "FILEDIA" old_fdia)


;=============================================================
;;;  
;;   (CMSF)****
  (defun cmsf (/ ent elist mvscale)
    (if	(= 0 (getvar "tilemode"))
      (progn
	  (if (setq ss1
	            (ssget "X" (list '(0 . "VIEWPORT") (cons 69 (getvar "cvport"))))
	      ) ;_ end of setq
	   (setq ent (ssname ss1 0))
	  ) ;_end of if
	(setq mvscale (msf ent)
	      my mvscale)
      )	;_end of progn tilemode /= 1
      (setq my (getvar "dimscale"))
    )	;_ end if tilemode = 0
  ) ;_ end of defun

  (defun msf (ent / vpxdata ms_height ps_height msf entxdata)
    (defun entxdata (ent appid / d)
      (if (and (setq d (entget ent (list appid)))
	       (setq d (assoc -3 d))
	       (cdadr d)
	  ) ;_ end of and
	(cdadr d)
      ) ;_ end of if
    ) ;_ end of defun
    (setq vpxdata   (entxdata ent "acad")
	  ms_height (cdr (nth 6 vpxdata))
	  ps_height (cdr (assoc 41 (entget ent)))
    ) ;_ end of setq
    (/ ms_height ps_height)
  ) ;_ end of defun msf

;;****
;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;  
(defun SetOpt ()
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

;  
(defun RetOpt ()
	(setvar "BLIPMODE" sblip)
	(setvar "CMDECHO" scmde)
)

;  OSNAP
(defun Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
        ;(setq apper (getvar "APERTURE"))
        ;(setq oscoor (getvar "OSNAPCOORD"))
	(setvar "OSMODE" 0)
        ;(setvar "APERTURE" 1)
        ;(setvar "OSNAPCOORD" 1)
)

;  OSNAP
(defun Osnap_On  ()
	(setvar "OSMODE" sosnapm)
        ;(setvar "APERTURE" apper)
        ;(setvar "OSNAPCOORD" oscoor)
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;    
(defun arcsin ( x / )
    (atan 
        (/  x  (sqrt (- 1.0 (* x x))) )
    )
) ; defun arsin

;-------------------------------------------------------------
;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;  SelObj
(defun MoveObj (SelObj BasePt)
	(command "_Move" SelObj "" bp pause)
	(setq BasePt (getvar "Lastpoint"))
	(princ (strcat "\n : " BasePt))
	T BasePt
)

;  SelObj
(defun RotateObj (SelObj BasePt)
	(princ "\n : ")
	(command "_Rotate" SelObj "" BasePt pause)
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	;(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun $RetLProp ()
;   
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	;(setvar "CELWEIGHT" oldWeight)
)

(defun $setLTypeDim ( / my)
;****	(if (= (getvar "TILEMODE") 0)   
;****		(setq Scale 1)                   ;   
;****		(setq Scale (getvar "dimscale")) ; 
;****		                                 ;    
;****	)
     (cmsf) ;****
     (setq Scale my) ;****
	(setq TxtCOL (getvar "DIMCLRD"))	    ; , - 
										    ;  

	(setq TxtH (* (getvar "DIMTXT") Scale))	;  
											;  

	(setq ArWD (getvar "DIMLWD"))	        ;  , - 
									        ;  
	
	(setvar "CECOLOR" (rtos TxtCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
)

;   rNum  
;n   
(defun Round ( rNum n / nrNum inrNum idnrNum rndNum)
    ;rNum -   (3.124446)
    ;n -     (2)
    ;nrNum - rNum,   10   n
    ;inrNum -   nrNum
    ;idnrNum -   nrNum,   10
    ;rndNum -  

     (setq nrNum (* rNum (expt 10 n)))     ;(312.446)
     (setq inrNum (atof (rtos nrNum 2 0))) ;(312.0)
     (setq nrNum (- nrNum inrNum))         ;(0.446)
     (setq rndNum nil)                     
     (while (null rndNum)
          (setq nrNum (* nrNum 10.0))                  ;(1- 4.46, 2- 4.6, 3- 6.0)
          (setq idnrNum (atof (rtos nrNum 2 0)))       ;(1- 4.0,  2- 4.0, 3- 6.0)
          (cond
               ((= idnrNum 4) (setq nrNum (- nrNum idnrNum)))                   ;(1- 0.46, 2- 0.6)
               ((< idnrNum 4) (setq rndNum (/ inrNum (expt 10.0 n))))           ;
               ((> idnrNum 4) (setq rndNum (/ (+ inrNum 1.0) (expt 10.0 n))))   ;(3- 3.13)
          )
     )
     t rndNum    ;  (3.13)
)

;;;   
;=============================================================

;;;    
;=============================================================
(defun im_ImgBoot (Tile SlideName f_color / x y)
  (setq	x (dimx_tile Tile)
	y (dimy_tile Tile)
  )
  (start_image Tile)
  (fill_image 0 0 x y f_color)
  (slide_image 0 0 x y SlideName)
  (end_image)
)

(defun act_imgb_RG_T0 ()
    (mode_tile "C_RG_T3" 1)
    (set_tile "error" "   ")
    (im_ImgBoot "imgb_RG_T0" "Rough(RG_t0)" 141 )
    (im_ImgBoot "imgb_RG_T1" "Rough(RG_t1)" 0 )
    (if (= RG_Pos_mode 1 )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" -15 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" -15 )
        )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" 0 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" 0 )
        )
    )
    (mode_tile "imgb_RG_T4" RG_TUn_mode) 
    (if (= RG_TUn_mode 0)
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 0 )
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
    )

    (Sdb_Enabled "true")
    (BC2_Enabled "true")
    (BR3_Enabled "true")

    (imgb_RG_T4_Enabled "true")
    (if (or (= RG_Type 2) (= RG_Type 3))
        (progn
            (set_tile "opt_RA" "1")
            (set_tile "opt_RG_R1" "1")
            (set_tile "pls_RG_CLS" "0")
            (setq RG_ParType 'Ra)
            (setq RG_ParRow '1)
            (setq RG_Cls '0)
            (set_RG_ValList1)
            (set_RG_ValList2)
        )
    )
    (get_RGVal)
    (setq RG_Type 0)
)

(defun act_imgb_RG_T1 ()
    (mode_tile "C_RG_T3" 1)
    (set_tile "error" "    ")
    (im_ImgBoot "imgb_RG_T0" "Rough(RG_t0)" 0 )
    (im_ImgBoot "imgb_RG_T1" "Rough(RG_t1)" 141 )
    (if (= RG_Pos_mode 1 )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" -15 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" -15 )
        )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" 0 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" 0 )
        )
    )

    (mode_tile "imgb_RG_T4" RG_TUn_mode) 
    (if (= RG_TUn_mode 0)
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 0 )
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
    )

    (Sdb_Enabled "true")
    (BC2_Enabled "true")
    (BR3_Enabled "true")

    (imgb_RG_T4_Enabled "true")    
    (if (or (= RG_Type 2) (= RG_Type 3))
        (progn
            (set_tile "opt_RA" "1")
            (set_tile "opt_RG_R1" "1")
            (set_tile "pls_RG_CLS" "0")
            (setq RG_ParType 'Ra)
            (setq RG_ParRow '1)
            (setq RG_Cls '0)
            (set_RG_ValList1)
            (set_RG_ValList2)
        )
    )
    (get_RGVal)
    (setq RG_Type 1)
)

(defun act_imgb_RG_T2 ()
    (mode_tile "C_RG_T3" 1)
    (set_tile "error" "  ")
    (im_ImgBoot "imgb_RG_T0" "Rough(RG_t0)" 0 )
    (im_ImgBoot "imgb_RG_T1" "Rough(RG_t1)" 0 )
    (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" 141 )
    (if (= RG_Pos_mode 1 )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" -15 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" -15 )
        )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" 0 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" 141 )
        )
    )

    (mode_tile "imgb_RG_T4" RG_TUn_mode) 
    (if (= RG_TUn_mode 0)
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 0 )
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
    )

    (Sdb_Enabled "true")
    (BC2_Enabled "false")
    (BR3_Enabled "false")

    (imgb_RG_T4_Enabled "true")
    (setq RG_Type 2)
)

(defun act_imgb_RG_T3 ()
    (mode_tile "C_RG_T3" 0)
    (set_tile "error" "  ")
    (im_ImgBoot "imgb_RG_T0" "Rough(RG_t0)" 0 )
    (im_ImgBoot "imgb_RG_T1" "Rough(RG_t1)" 0 )
    (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" 0 )
    (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" 141 )
    
    (Sdb_Enabled "false")
    (BC2_Enabled "false")
    (BR3_Enabled "false")

    (imgb_RG_T4_Enabled "false")    
    (setq RG_Type 3)
    ;(mode_tile "txt_RG_Pos" 2)
)

(defun act_chk_RG_Sdb ()
    (setq RG_Sdb (get_tile "chk_RG_Sdb"))
)

(defun act_img_RG_N1 ()
    (if (= RG_TN 1)
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 141 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz1)" 0 )
            (setq RG_TN 1)
        )
    )
)

(defun act_img_RG_N2 ()
    (if (= RG_TN 2)
        (progn
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 141 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz2)" 0 )
            (setq RG_TN 2)
        )
    )
)

(defun act_img_RG_N3 ()
    (if (= RG_TN 3)
        (progn
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 141 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz3)" 0 )
            (setq RG_TN 3)
        )
    )
)

(defun act_img_RG_N4 ()
    (if (= RG_TN 4)
        (progn
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 141 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz4)" 0 )
            (setq RG_TN 4)
        )
    )
)

(defun act_img_RG_N5 ()
    (if (= RG_TN 5)
        (progn
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 141 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz5)" 0 )
            (setq RG_TN 5)
        )
    )
)

(defun act_img_RG_N6 ()
    (if (= RG_TN 6)
        (progn
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
        (progn
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 141 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz6)" 0 )
            (setq RG_TN 6)
        )
    )
)

;    RG_TUnSet 
; RG_TUnSet=0 -    
; RG_TUnSet=1 -  " "
(defun act_imgb_RG_T4 ()
    (if (= RG_TUnSet 0)
        (if (= RG_TUn_mode 1)
            (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
            (progn
                (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 141 )
                (setq RG_TUnSet 1)
            )
        )
        (progn
            (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 0 )
            (setq RG_TUnSet 0)
        )
    )
)

;     (Rz  Ra)
(defun act_RGParType ()
    (if (= (get_tile "opt_RA") "1")
        (setq RG_ParType 'Ra)
        (setq RG_ParType 'Rz)
    )
    (set_RG_ValList1)
    (set_RG_ValList2)
    (get_RGVal)
)

;      
(defun act_pls_RG_R1 ()
    (setq RG_ParRow1 (+ (atoi (get_tile "pls_RG_R1")) 1))
    (set_RG_ValList1)
    (get_RGVal)
)

;      
(defun act_pls_RG_R2 ()
    (setq RG_ParRow2 (+ (atoi (get_tile "pls_RG_R2")) 1))
    (set_RG_ValList2)
    (get_RGVal)
)

;      
(defun act_pls_RG_CLS1 ()
    (setq RG_Cls1 (atoi (get_tile "pls_RG_CLS1")))
    (set_RG_ValList1)
    (get_RGVal)
)

;      
(defun act_pls_RG_CLS2 ()
    (setq RG_Cls2 (atoi (get_tile "pls_RG_CLS2")))
    (set_RG_ValList2)
    (get_RGVal)
)

;   
(defun act_pls_RG_V1 ()
    (get_RGVal)
)

;       
(defun act_pls_RG_T ( / n)
    (setq n (atoi (get_tile "pls_RG_T")))
    (cond
        ((= n 0) (setq RG_T ""))
        ((= n 1) (setq RG_T ""))
        ((= n 2) (setq RG_T ""))
        ((= n 3) (setq RG_T ""))
        ((= n 4) (setq RG_T ""))
        ((= n 5) (setq RG_T ""))
        ((= n 6) (setq RG_T ""))
        ((= n 7) (setq RG_T ""))
        ((= n 8) (setq RG_T ""))
    )
    (set_tile "txt_RG_T" RG_T)
)

;   
(defun act_txt_RG_T ( )
    (setq RG_T (get_tile "txt_RG_T"))
)

;     
(defun act_txt_RG_BL1 ()
    (if (or (null (get_tile "txt_RG_BL1")) (= (get_tile "txt_RG_BL1") ""))
        (progn
            (if (= (get_tile "error") "   ")
                (set_tile "error" "")
            )
            (setq RG_BL1 (get_tile "txt_RG_BL1"))
        )
        (if (not (setq RG_BL1 (ai_num (get_tile "txt_RG_BL1") "   " 4)))
        	(mode_tile "txt_RG_BL1" 2)
        	(progn
                (if (= (get_tile "error") "   ")
                    (set_tile "error" "")
                )
        	    (setq RG_BL1 (get_tile "txt_RG_BL1"))
        	)
        )
    )
    ;(setq RG_BL1 (get_tile "txt_RG_BL1"))
)

;     
(defun act_txt_RG_BL2 ()
    (if (or (null (get_tile "txt_RG_BL2")) (= (get_tile "txt_RG_BL2") ""))
        (progn
            (if (= (get_tile "error") "   ")
                (set_tile "error" "")
            )
            (setq RG_BL2 (get_tile "txt_RG_BL2"))
        )
        (if (not (setq RG_BL2 (ai_num (get_tile "txt_RG_BL2") "   " 4)))
        	(mode_tile "txt_RG_BL2" 2)
        	(progn
                (if (= (get_tile "error") "   ")
                    (set_tile "error" "")
                )
        	    (setq RG_BL1 (get_tile "txt_RG_BL2"))
        	)
        )
    )
    ;(setq RG_BL2 (get_tile "txt_RG_BL2"))
)

(defun act_txt_RG_Pos ()
    (setq RG_Pos (get_tile "txt_RG_Pos"))
    ((= RG_Type 3)
        (if (or (null RG_Pos) (= RG_Pos ""))
            (progn
                (setq RG_Pos "")
                (set_tile "error" "  ")
                (mode_tile "txt_RG_Pos" 2)
            )
            (if (= (get_tile "error") "  " )
                (set_tile "error" "")
            )
        )
    )

)

;      
(defun BC2_Enabled (value)
    (if (= value "false")
        (progn ;   
            (mode_tile "BC2" 1)
        )
        (progn ;  
            (mode_tile "BC2" 0)
        )
    )
)

;    " "
(defun Sdb_Enabled (value)
  (if (not (= RG_Pos_mode 1 ))
    (if (= value "false")
        (progn ;   
            (set_tile "chk_RG_Sdb" "0")
            (mode_tile "chk_RG_Sdb" 1)
            (act_chk_RG_Sdb)
        )
        (progn ;  
            (mode_tile "chk_RG_Sdb" 0)
            (act_chk_RG_Sdb)
        )
    )
    (progn ;   
        (set_tile "chk_RG_Sdb" "0")
        (mode_tile "chk_RG_Sdb" 1)
        (act_chk_RG_Sdb)
    )
  )
)

;    " "
(defun BR3_Enabled (value)
    (if (= value "false")
        (progn ;   
            (mode_tile "BR3" 1)
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" -15 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" -15 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" -15 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" -15 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" -15 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" -15 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" -15 )
            (setq RG_TN 0)
        )
        (progn ;  
            (mode_tile "BR3" 0)
            (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
            (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
            (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
            (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
            (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
            (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
            (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
            (setq RG_TN 0)
        )
    )
)

;    " "
(defun imgb_RG_T4_Enabled (value)
  (if (= RG_TUn_mode 1)
     (progn
         (mode_tile "imgb_RG_T4" 1)
         (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
     )
     (if (= value "false")
        (progn ;   
            (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
            (setq RG_TUnSet 2)
            (mode_tile "imgb_RG_T4" 1)
        )
        (if (= RG_TUnSet 2) ;   " "  
            (progn ;  
                (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 0 )
                (setq RG_TUnSet 0)
            )
            (mode_tile "imgb_RG_T4" 0)
        )
     )
  )
)

;   
(defun bad_par_RG ()
    (setq RG_BL1 (get_tile "txt_RG_BL1"))
    (setq RG_BL2 (get_tile "txt_RG_BL2"))
    (setq RG_Pos (get_tile "txt_RG_Pos"))
    (cond
        ((or (= RG_Val1 "") (= RG_Val1 " "))
            (set_tile "error" "       ")
            (set_tile "error" "")
        )
        ((and (not (= RG_BL1 "")) (not (ai_num RG_BL1 (strcat "  : " RG_BL1) 4)))
            (mode_tile "txt_RG_BL1" 2)
        )
        ( (and (not (= RG_BL2 "")) (not (ai_num RG_BL2 (strcat "  : " RG_BL2) 4)))
            (mode_tile "txt_RG_BL2" 2)
        )
        ((and (and (or (null RG_Pos) (= RG_Pos ""))) (= RG_Type 3) )
            (progn
                (set_tile "error" "  ")
                (mode_tile "txt_RG_Pos" 2)
            )
        )
        (t (done_dialog 1))
    )
)

;;;     
;=============================================================

;      
(defun make_RG_ParList ( / RG_ParList 
                           RA_Row1 RA_Row2 RA_Row3 RA_Row4 
                           RZ_Row1 RZ_Row2 RZ_Row3 RZ_Row4
                           RA_ParList
                           RZ_ParList )
    
    (setq RA_Row1 (list "50"  "25"  "12,5" "6,3" "3,2"  "1,6"  "0,80" "0,40" "0,20" "0,10"  "0,050" "0,025" "0,012" ""   )) 
    (setq RA_Row1 (list '1 RA_Row1))
    
    (setq RA_Row2 (list "80"  "40"  "20"   "10"  "5"    "2,5"  "1,25" "0,63" "0,32" "0,160" "0,080" "0,040" "0,020" "0,010" ))
    (setq RA_Row2 (list '2 RA_Row2))
    
    (setq RA_Row3 (list "63"  "32"  "16"   "8"   "4"    "2,0"  "1,00" "0,50" "0,25" "0,125" "0,063" "0,032" "0,016" "0,008" ))
    (setq RA_Row3 (list '3 RA_Row3))
    
    (setq RA_Row4 (list "40"  "20"  "10"   "5"   "2,5"  "1,25" "0,63" "0,32" "0,16" "0,080" "0,040" "0,020" "0,010" ""   ))
    (setq RA_Row4 (list '4 RA_Row4))
    
    (setq RZ_Row1 (list "320" "160" "80"   "40"  "20"   "10,0" "6,3"  "3,2"  "1,60" "0,80"  "0,40"  "0,20"  "0,100" "0,050" ))
    (setq RZ_Row1 (list '1 RZ_Row1))
    
    (setq RZ_Row2 (list "250" "125" "63"   "32"  "16"   "8,0"  "5,0"  "2,5"  "1,25" "0,63"  "0,32"  "0,16"  "0,080" "0,040" ))
    (setq RZ_Row2 (list '2 RZ_Row2))
    
    (setq RZ_Row3 (list "200" "100" "50"   "25"  "12,5" "6,3"  "4,0"  "2,0"  "1,00" "0,50"  "0,25"  "0,125" "0,063" "0,032" ))
    (setq RZ_Row3 (list '3 RZ_Row3))
    
    (setq RZ_Row4 (list "160" "80"  "40"   "20"  "10"   ""  "3,2"  "1,60" "0,80" "0,40"  "0,20"  "0,100" "0,050" ""   ))
    (setq RZ_Row4 (list '4 RZ_Row4))
    
    (setq RA_ParList (list RA_Row1 RA_Row2 RA_Row3 RA_Row4))
    (setq RZ_ParList (list RZ_Row1 RZ_Row2 RZ_Row3 RZ_Row4))
    
    (setq RG_ParList
        (list
            (cons '0 "RG_ParList")
            (cons 'RA RA_ParList)
            (cons 'RZ RZ_ParList)
        )
    )
    t RG_ParList
)

;      
(defun set_RG_ValList1 ( / l_val)
    (setq l_val (cdr (assoc RG_ParType RG_ParList)))
    (setq l_val (car (cdr (assoc RG_ParRow1 l_val))))
    (if (> RG_Cls1 0)
        (setq l_val (list (nth (- RG_Cls1 1) l_val)))
    )

    (start_list "pls_RG_V1" 3)
    (mapcar 'add_list l_val)
    (end_list)
)

;      
(defun set_RG_ValList2 ( / l_val)
    (setq l_val (cdr (assoc RG_ParType RG_ParList)))
    (setq l_val (car (cdr (assoc RG_ParRow2 l_val))))
    (if (> RG_Cls2 0)
        (setq l_val (list (nth (- RG_Cls2 1) l_val)))
    )
   
    (start_list "pls_RG_V2" 3)
    (mapcar 'add_list (cons "" l_val))
    (end_list)
)

;    
(defun get_RGVal ( / n1 n2 l_val1 l_val2)
    (setq n1 (atoi (get_tile "pls_RG_V1")))
    (setq n2 (atoi (get_tile "pls_RG_V2")))
    (setq l_val1 (cdr (assoc RG_ParType RG_ParList)))
    (setq l_val1 (car (cdr (assoc RG_ParRow1 l_val1))))
    (if (> RG_Cls1 0)
        (setq RG_Val1 (nth (- RG_Cls1 1) l_val1))
        (setq RG_Val1 (nth n1 l_val1))
    )
    (setq l_val2 (cdr (assoc RG_ParType RG_ParList)))
    (setq l_val2 (car (cdr (assoc RG_ParRow2 l_val2))))
    (if (> RG_Cls2 0)
        (if (> n2 0)
            (setq RG_Val2 (nth (- RG_Cls2 1) l_val2))
            (setq RG_Val2 "")
        )
        (if (> n2 0)
           (setq RG_Val2 (nth (- n2 1) l_val2))
           (setq RG_Val2 "")
        )
    )
    (if (or (= RG_Val1 "") (= RG_Val1 " "))
        (set_tile "error" "       ")
        (if (= (get_tile "error") "       ")
            (set_tile "error" "")
        )
    )
)


;;;  
;=============================================================

;     
;  
(defun GetRough ( RG_TUnSet RG_TUn_mode RG_Pos_mode / RG_ParList RG_List RG_Type 
                    RG_TN RG_ParType RG_ParRow1 RG_ParRow2 RG_Cls1 RG_Cls2
                    RG_Val1 RG_Val2 RG_T RG_Pos RG_Sdb)
    ; RG_TUn_mode -    " "
    ; RG_ParList -    
    ; RG_List -   
    ; RG_Type -  
    ; RG_TUnSet -    
    ; RG_TN -  
    ; RG_ParType -    (Ra  Rz)
    ; RG_ParRow -    
    ; RG_Cls -   
    ; RG_Val1 -    
    ; RG_Val2 -    
    ; RG_T -  
    ; RG_BL -  
    ; RG_Pos -  
    ; RG_Sdb -   " "
    
    (setq RG_Pos "")
    (setq RG_ParList (make_RG_ParList))
    
    (setq RG_List nil)
    
    ;    
    (setq dcl_id (load_dialog "Rough.dcl"))
    (if (not (new_dialog "Rough" dcl_id))   ;   .
        (exit)                                  ; ,     
                                                ;   .
    )

    (action_tile "accept" "(bad_par_RG)")
    
    //(mode_tile "C_RG_T3" 1)
    
    (set_tile "error" "   ")
    (setq RG_Type 0)
    
    (im_ImgBoot "imgb_RG_T0" "Rough(RG_t0)" 141 )
    (im_ImgBoot "imgb_RG_T1" "Rough(RG_t1)" 0 )
    
    (mode_tile "imgb_RG_T2" RG_Pos_mode)
    (mode_tile "imgb_RG_T3" RG_Pos_mode)
    (if (= RG_Pos_mode 1 )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" -15 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" -15 )
            (Sdb_Enabled "false")
        )
        (progn
            (im_ImgBoot "imgb_RG_T3" "Rough(RG_t3)" 0 )
            (im_ImgBoot "imgb_RG_T2" "Rough(RG_t2)" 0 )
        )
    )
    
    (mode_tile "imgb_RG_T4" RG_TUn_mode) 
    (if (= RG_TUn_mode 0)
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" 0 )
        (im_ImgBoot "imgb_RG_T4" "Rough(RG_t4)" -15 )
    )
    
    (action_tile "imgb_RG_T0" "(act_imgb_RG_T0)" )
    (action_tile "imgb_RG_T1" "(act_imgb_RG_T1)" )
    (action_tile "imgb_RG_T2" "(act_imgb_RG_T2)" )
    (action_tile "imgb_RG_T3" "(act_imgb_RG_T3)" )
    (action_tile "imgb_RG_T4" "(act_imgb_RG_T4)" )
    
    
    (setq RG_TN 0)
    
    (mode_tile "img_RG_N6" 0)

    (im_ImgBoot "img_RG_N1" "Rough(RG_ns1)" 0 )
    (im_ImgBoot "img_RG_N2" "Rough(RG_ns2)" 0 )
    (im_ImgBoot "img_RG_N3" "Rough(RG_ns3)" 0 )
    (im_ImgBoot "img_RG_N4" "Rough(RG_ns4)" 0 )
    (im_ImgBoot "img_RG_N5" "Rough(RG_ns5)" 0 )
    (im_ImgBoot "img_RG_N6" "Rough(RG_ns6)" 0 )
    
    (im_ImgBoot "img_RG_N" "Rough(RG_nz0)" 0 )
    
    (action_tile "img_RG_N1" "(act_img_RG_N1)" )
    (action_tile "img_RG_N2" "(act_img_RG_N2)" )
    (action_tile "img_RG_N3" "(act_img_RG_N3)" )
    (action_tile "img_RG_N4" "(act_img_RG_N4)" )
    (action_tile "img_RG_N5" "(act_img_RG_N5)" )
    (action_tile "img_RG_N6" "(act_img_RG_N6)" )

    (setq RG_ParType 'Ra)
    (action_tile "opt_RA" "(act_RGParType)" )
    (action_tile "opt_RZ" "(act_RGParType)" )
    
    (setq RG_ParRow1 '1)
    (action_tile "pls_RG_R1" "(act_pls_RG_R1)")
    
    (setq RG_ParRow2 '1)
    (action_tile "pls_RG_R2" "(act_pls_RG_R2)")
    
    
    (setq RG_Cls1 '0)
    (action_tile "pls_RG_CLS1" "(act_pls_RG_CLS1)")

    (setq RG_Cls2 '0)
    (action_tile "pls_RG_CLS2" "(act_pls_RG_CLS2)")
    
    (action_tile "pls_RG_V1" "(act_pls_RG_V1)")
    (action_tile "pls_RG_V2" "(act_pls_RG_V1)")
    (setq RG_Val1 "50")
    (setq RG_Val2 "")
    
    (action_tile "pls_RG_T" "(act_pls_RG_T)")
    (action_tile "txt_RG_T" "(act_txt_RG_T)")
    (setq RG_T "")
    
    (action_tile "txt_RG_BL1" "(act_txt_RG_BL1)")
    (setq RG_BL1 "")

    (action_tile "txt_RG_BL2" "(act_txt_RG_BL2)")
    (setq RG_BL2 "")
    
    (action_tile "chk_RG_Sdb" "(act_chk_RG_Sdb)")
    (setq RG_Sdb "0")
    
    (action_tile "Ok" "(done_dialog 1)")
    (action_tile "cancel" "(done_dialog 0)")

    (if ( = 1 (start_dialog))
        (progn
            (unload_dialog dcl_id)
            (setq RG_List (list
			    (cons '0 "ROUGH")
			    (cons 'RG_Type RG_Type)
			    (cons 'RG_TUnSet RG_TUnSet)
			    (cons 'RG_TN RG_TN)
			    (cons 'RG_ParType RG_ParType)
			    (cons 'RG_ParRow1 RG_ParRow1)
			    (cons 'RG_Cls1 RG_Cls1)
			    (cons 'RG_Val1 RG_Val1)
			    (cons 'RG_ParRow2 RG_ParRow2)
			    (cons 'RG_Cls2 RG_Cls2)
			    (cons 'RG_Val2 RG_Val2)
			    (cons 'RG_T RG_T)
			    (cons 'RG_BL1 RG_BL1)
			    (cons 'RG_BL2 RG_BL2)
			    (cons 'RG_Pos RG_Pos)
			    (cons 'RG_Sdb RG_Sdb)
			  )
            )
        )
        (progn
            (setq RG_Type nil)
            (setq RG_List nil)
            (unload_dialog dcl_id)
        )
    )
    t RG_List
)

;  
(defun ins_Txt (t_pt t_ang t_just t_h txt / t_l t_list th CurTxtStyle)
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))

    (if (> th 0)
        (if (not (null t_just))
            (command "_text" "_J" t_just t_pt (rtd t_ang) txt)
            (command "_text" t_pt (rtd t_ang) txt)
        )
        (if (not (null t_just))
            (command "_text" "_J" t_just t_pt t_h (rtd t_ang) txt)
            (command "_text" t_pt t_h (rtd t_ang) txt)
        )
    )
    (setq t_list (list (cons '1 txt) (cons '40 t_h)))
    (setq t_l (car (cadr (textbox t_list))))
    t t_l
)



;    " "
(defun drw_RG (RG_List pt ang 
                / Scale SS b_Name RG_M_LIST
                  cp pt1 pt2
                  RG_VAL2 RG_BL2 CurTxtStyle th my
                  RG_Sdb)
                  
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))

;****	(if (= (getvar "TILEMODE") 0)   
;****		(setq Scale 1)                   ;   
;****		(setq Scale (getvar "dimscale")) ; 
;****		                                 ;    
;****	)
    (cmsf) ;****
    (setq Scale my) ;****
   
    (setq RG_VAL2 (cdr (assoc 'RG_VAL2 RG_List)))
    (setq RG_BL2 (cdr (assoc 'RG_BL2 RG_List)))
    (setq RG_TYPE (cdr (assoc 'RG_TYPE RG_List)))
    (setq RG_Sdb (cdr (assoc 'RG_Sdb RG_List)))
    
    (setq m_Len (* 4.6178  Scale)) ;   
    (if (or (and (not (= RG_VAL2 "")) (not (= RG_VAL2 "")))
            (and (not (= RG_BL2 "")) (not (= RG_BL2 ""))))
        (if (= th 0.0)
            (setq b_Len (* 14.85641 Scale)) ;   
            (setq b_Len (* 1.15 13.049052 Scale))
        )
        (if (= th 0.0)
            (setq b_Len (* 11.2376  Scale))  ;   
            (setq b_Len (* 1.15 10.032696 Scale))
        )
    )

    (setq R (* 1.33333 Scale)) ;   
    (setq cp (polar pt (+ ang (dtr 90)) (* 2.66666 Scale))) ;   

    (osnap_off)
    ($SaveLProp)
    ($setLTypeDim)

    (setq SS (ssadd))
    (command "_line" pt (setq pt1 (polar pt (+ ang (dtr 60)) b_Len)) "") ;  
    (ssadd (entlast) SS)
    (setq b_Name (entlast)) ;   " "
    (command "_line" pt (setq pt2 (polar pt (+ ang (dtr 120)) m_Len)) "") ;  
    (ssadd (entlast) SS)
    (cond
        ((= RG_TYPE 1)
            (progn
                (command "_line" pt2 (polar pt2 ang m_Len) "")
                (ssadd (entlast) SS)
            )
        )
        ((= RG_TYPE 2)
            (progn
                (command "_circle" cp R)
                (ssadd (entlast) SS)
            )
        )
    )
    (if (= RG_Sdb "1")
        (progn
            (command "_circle" (polar pt (+ ang (dtr 60)) b_Len) (* 1.2 Scale))
            (ssadd (entlast) SS)
        )
    )
    (osnap_on)
    ($RetLProp)
    
    (setq RG_M_LIST (list b_Name SS))
    t RG_M_LIST
)

;   
(defun ins_RG_Val (RG_List pt ang SS / RG_VAL1 RG_VAL2 Scale bh ins_pt CurTxtStyle th t_ang Just my)
	(setq RG_VAL1 (cdr (assoc 'RG_VAL1 RG_List)))
	(setq RG_VAL2 (cdr (assoc 'RG_VAL2 RG_List)))
	(setq RG_PARTYPE (cdr (assoc 'RG_PARTYPE RG_List)))
	
	(if (= RG_PARTYPE 'RZ)
	    (progn
	        (setq RG_VAL1 (strcat "Rz" RG_VAL1))
	        (if (not (= RG_VAL2 ""))
	            (setq RG_VAL2 (strcat "Rz" RG_VAL2))
	        )
	    )
	)
	
	(cond
	    ((and (>= ang 0) (<= ang (dtr 90.5)))
	        (progn
	            (setq t_ang ang)
	            (setq Just "_R")
	        )
	    )
	    ((and (> ang (dtr 90)) (<= ang (dtr 360)))
	        (progn
	            (setq t_ang (- ang (dtr 180)))
	            (setq Just "_TL")
	        )
	    )
	    ((and (< ang 0) (> ang (dtr (- 180)))) 
	        (progn
	            (setq t_ang ang)
	            (setq Just "_R")
	        )
	    )
	)
	
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))

;****	(if (= (getvar "TILEMODE") 0)   
;****		(setq Scale 1)                   ;   
;****		(setq Scale (getvar "dimscale")) ; 
;****		                                 ;    
;****	)
	(cmsf) ;****
        (setq Scale my) ;****
         
	(setq ins_pt (polar pt ang (* 2.193571 Scale)))
	(setq ins_pt (polar ins_pt (+ ang (dtr 90)) (* 5.140436 Scale)))

    (osnap_off)
    ($SaveLProp)
    ($setLTypeDim)
    
    (if (= RG_Val2 "")
        (progn
            (if (= th 0.0)
  		        (command "_text" "_Justify" Just ins_pt (* 4 Scale) (rtd t_ang) RG_Val1)
			    (command "_text" "_Justify" Just ins_pt (rtd t_ang) RG_Val1)
            )
            (ssadd (entlast) SS)
        )
        (progn
            (if (= th 0.0)
  		        (progn
  		            (command "_text" "_Justify" Just ins_pt (* 3.5 Scale) (rtd t_ang) RG_Val2)
  		            (ssadd (entlast) SS)
  		            (setq ins_pt (polar ins_pt (+ ang (dtr 90)) (* 4.5 Scale)))
  		            (command "_text" "_Justify" Just ins_pt (* 3.5 Scale) (rtd t_ang) RG_Val1)
  		            (ssadd (entlast) SS)
  		        )
			    (progn
			        (command "_text" "_Justify" Just ins_pt (rtd t_ang) RG_Val2)
			        (ssadd (entlast) SS)
			        (setq ins_pt (polar ins_pt (+ ang (dtr 90)) (* (+ 1 th) Scale)))
			        (command "_text" "_Justify" Just ins_pt (rtd t_ang) RG_Val1)
			        (ssadd (entlast) SS)
			    )
            )
        )
    )

    (osnap_on)
    ($RetLProp)

    t SS
)

;   " "
(defun ins_RG_TN (RG_List pt ang SS / ins_ang ins_pt Scale RG_TN sh_name dx r_list my)
    (setq RG_TN (cdr (assoc 'RG_TN RG_List)))
    (if (> RG_TN  0)
        (progn
;****	        (if (= (getvar "TILEMODE") 0)   
;****		        (setq Scale 1)                   ;   
;****		        (setq Scale (getvar "dimscale")) ; 
;****		                                         ;    
;****	        )
            (cmsf) ;****
            (setq Scale my) ;****
            (setq sh_name (strcat "RG" (rtos RG_TN 2 0)))
            ;(while (> (abs ang) (dtr 360))
            ;    (setq ang (- ang (dtr 360)))
            ;)
            (if (or (> (round (cos ang) 4) 0.0) (= (round ang 4) (round (dtr 90.0) 4)))
                (progn
                    (setq ins_ang ang)
                    (setq ins_pt pt)
                )
                (progn
                    (setq ins_ang (- ang (dtr 180)))
                    (setq ins_pt (polar
                                     (polar pt ang (* 10 Scale))
                                     (+ ang (dtr 90))
                                     (* 5 Scale)
                                 )
                    )
                )
            )
            (osnap_off)
            ($SaveLProp)
            ($setLTypeDim)
	        (command "_shape" sh_name ins_pt scale (rtd ins_ang))
	        (osnap_on)
	        ($RetLProp)
	        (ssadd (entlast) SS)
	        (setq dx (* 7.0 Scale))
	        (setq r_list (list SS dx))
        )
    )
    t r_list
)

;    
(defun ins_bl (RG_List ang SS pt3 dx / Scale RG_BL1 RG_BL2 ins_ang ins_pt Just 
                                       dy bl_dx bl_dx1 bl_dx2 r_list txt_h my)
;****    (if (= (getvar "TILEMODE") 0)   
;****        (setq Scale 1)                   ;   
;****  	     (setq Scale (getvar "dimscale")) ; 
;****	                                     ;    
;****	)
    (cmsf) ;****
    (setq Scale my) ;****

    (setq Just nil)
    (setq dy (* Scale 0.5))
    (setq RG_BL1 (cdr (assoc 'RG_BL1 RG_List)))
    (setq RG_BL2 (cdr (assoc 'RG_BL2 RG_List)))
    (if (and (not (= RG_BL1 "")) (not (= RG_BL2 "")))
        (setq txt_h 3.5)
        (setq txt_h 4.0)
    )
    (if (or (> (round (cos ang) 4) 0.0) (= (round ang 4) (round (dtr 90.0) 4)))
        (progn
            (setq Just "_TL")
            (setq ins_ang ang)
            (setq ins_pt (polar pt3 (- ang (dtr 90)) dy))
        )
        (progn
            (setq Just "_R")
            (setq ins_ang (- ang (dtr 180)))
            (setq ins_pt (polar pt3 (- ang (dtr 90)) dy))
        )
    )
    (setq dx 0.0)
    (if (not (= RG_BL1 ""))
        (progn
            (osnap_off)
            ($SaveLProp)
            ($setLTypeDim)
            (setq bl_dx1 (ins_Txt ins_pt ins_ang Just (* txt_h Scale) RG_BL1))
	        (osnap_on)
	        ($RetLProp)
	        (ssadd (entlast) SS)
	        (if (> bl_dx1 dx)
	            (setq bl_dx bl_dx1)
	            (setq bl_dx dx)
	        )
	        (setq r_list (list SS bl_dx))
	        (setq dy (* Scale (+ 1 txt_h)))
	        (setq ins_pt (polar pt3 (- ang (dtr 90)) dy))
        )
    )
    (if (not (= RG_BL2 ""))
        (progn
            (osnap_off)
            ($SaveLProp)
            ($setLTypeDim)
            (setq bl_dx2 (ins_Txt ins_pt ins_ang Just (* txt_h Scale) RG_BL2))
	        (osnap_on)
	        ($RetLProp)
	        (ssadd (entlast) SS)
	        (if (> bl_dx2 dx)
	            (setq bl_dx bl_dx2)
	            (setq bl_dx dx)
	        )
	        (setq r_list (list SS bl_dx))
        )
    )
    t r_list
)

;    
(defun ins_T ( ang SS pt3 dx RG_List / 
               r_list Scale RG_T txt_h Just bl_dx ins_pt ins_ang pt4 my)
;****    (if (= (getvar "TILEMODE") 0)   
;****        (setq Scale 1)                   ;   
;****	     (setq Scale (getvar "dimscale")) ; 
;****	                                     ;    
;****	)
    (cmsf) ;****
    (setq Scale my) ;****
    (setq Just nil)
    (setq RG_T (cdr (assoc 'RG_T RG_List)))
    (setq txt_h 4.0)
    (if (or (> (round (cos ang) 4) 0.0) (= (round ang 4) (round (dtr 90.0) 4)))
        (progn
            (setq Just nil)
            (setq ins_ang ang)
            (setq ins_pt (polar pt3 (+ ang (dtr 90)) (* Scale 0.5)))
            (setq ins_pt (polar ins_pt ang (* 2 Scale)))
        )
        (progn
            (setq Just "_TR")
            (setq ins_ang (- ang (dtr 180)))
            (setq ins_pt (polar pt3 (+ ang (dtr 90)) (* Scale 0.5)))
            (setq ins_pt (polar ins_pt ang (* 2 Scale)))
        )
    )
    (if (not (= RG_T ""))
        (progn
            (osnap_off)
            ($SaveLProp)
            ($setLTypeDim)
            (setq bl_dx (ins_Txt ins_pt ins_ang Just (* txt_h Scale) RG_T))
            (ssadd (entlast) SS)
            (setq pt4 (polar pt3 ang (+ bl_dx (* 1 Scale))))
            (command "_line" pt3 pt4 "")
	        (osnap_on)
	        ($RetLProp)
	        (ssadd (entlast) SS)
	        (if (> bl_dx dx)
	            (setq bl_dx bl_dx)
	            (setq bl_dx dx)
	        )
	        (setq r_list (list SS bl_dx))
        )
    )    
    t r_list
)

;   
(defun ins_RG_Pos (RG_List pt ang SS / RG_Pos Scale Pos_dx ins_pt CurTxtStyle t_ang Just my)
	
	(setq RG_Pos (cdr (assoc 'RG_Pos RG_List)))
;****	(if (= (getvar "TILEMODE") 0)   
;****		(setq Scale 1)                   ;   
;****		(setq Scale (getvar "dimscale")) ; 
;****		                                 ;    
;****	)
        (cmsf) ;****
        (setq Scale my) ;****
	
	(cond
	    ((and (>= ang 0) (<= ang (dtr 90.5)))
	        (progn
	            (setq t_ang ang)
	            (setq Just "_R")
	            (setq ins_pt (polar pt ang (* 0.193571 Scale)))
	            (setq ins_pt (polar ins_pt (+ ang (dtr 90)) (* 5.140436 Scale)))
	        )
	    )
	    ((and (> ang (dtr 90)) (<= ang (dtr 360)))
	        (progn
	            (setq t_ang (- ang (dtr 180)))
	            (setq Just "_TL")
	            (setq ins_pt (polar pt ang (* 2.193571 Scale)))
                    (setq ins_pt (polar ins_pt (+ ang (dtr 90)) (* 5.140436 Scale)))
	        )
	    )
	    ((and (< ang 0) (> ang (dtr (- 180)))) 
	        (progn
	            (setq t_ang ang)
	            (setq Just "_R")
	            (setq ins_pt (polar pt ang (* 0.193571 Scale)))
	            (setq ins_pt (polar ins_pt (+ ang (dtr 90)) (* 5.140436 Scale)))
	        )
	    )
	)
	
	

    (osnap_off)
    ($SaveLProp)
    ($setLTypeDim)
    
    (if (not (= RG_Pos ""))
        (progn
            (setq Pos_dx (ins_Txt ins_pt t_ang Just (* 4 Scale) RG_Pos))
            (ssadd (entlast) SS)
        )
    )

    (osnap_on)
    ($RetLProp)

    t SS
)

;   " "
(defun ins_RG_TUNSET (ins_pt SS / Scale pt1 pt2 pt3 my)
;****	(if (= (getvar "TILEMODE") 0)   
;****		(setq Scale 1)                   ;   
;****		(setq Scale (getvar "dimscale")) ; 
;****		                              ;    
;****	)
    (cmsf) ;****
    (setq Scale my) ;****
    (setq ins_pt (polar ins_pt 0 (* 5 Scale)))
    (setq pt1 (polar ins_pt (dtr 255) (* 1 scale)))
    (setq pt2 (polar ins_pt (dtr 83) (* 6 scale)))
    (setq pt3 (polar ins_pt (dtr 75) (* 10 scale)))
    (osnap_off)
    ($SaveLProp)
    ($setLTypeDim)
    (command "_arc" pt1 pt2 pt3)
    (ssadd (entlast) SS)
    (setq ins_pt (polar ins_pt 0 (* 3 Scale)))
    (setq pt1 (polar ins_pt (dtr 120) (* 4 scale)))
    (setq pt2 (polar ins_pt (dtr 60) (* 10 scale)))
    (command "_pline" pt1 ins_pt pt2 "")
    (ssadd (entlast) SS)
    (setq ins_pt (polar ins_pt 0 (* 3 Scale)))
    (setq pt1 (polar ins_pt (dtr 255) (* 1 scale)))
    (setq pt2 (polar ins_pt (dtr 67) (* 6 scale)))
    (setq pt3 (polar ins_pt (dtr 75) (* 10 scale)))
    (command "_arc" pt1 pt2 pt3)
    (ssadd (entlast) SS)
    ($RetLProp)
    (osnap_on)
    t SS
)


;     
(defun C:Rough ( / RG_List RG_List_p pt pt_p RG_M_List RG_M_List_p SS SS_p e_name th
                   e_list ang pt3 dx Sc RG_PARTYPE RG_Val1 RG_Val2 LS1 LS2 RG_TUNSET my)
    ; RG_List -   
    ; pt -   
    ; RG_M_List -    

;****	(if (= (getvar "TILEMODE") 0)   
;****		(setq Sc 1)                   ;   
;****		(setq Sc (getvar "dimscale")) ; 
;****		                              ;    
;****	)
       (cmsf) ;****
       (setq Sc my) ;****
    ;(setq RG_List_p (GetRough 0 1 1)) ;     
                                     ;    
                                     ; " ", " "
                                     ;  "  "
                                     ;     
                                     ;    " "
                                     ; RG_Type = 3
    
    (setq RG_List (GetRough 0 0 0)) ;     
                                     ; c   
                                     ; " "  " ",
                                     ;     
    
    (if (not (null RG_List)) 
        (progn
            (setq dx 0.0)
            (setq RGL RG_List)
            (setq pt (getpoint "\n  : "))
            ;(osnap_off)
            (setq RG_M_List (drw_RG RG_List pt 0))
            ;(osnap_on)
            (setq pt_UNSET pt)
            

            (setq e_name (car RG_M_List))
            (setq SS (cadr RG_M_List))
            (if (not (= (cdr (assoc 'RG_TUNSET RG_List)) 1))
                (progn
                    (setq e_list (entget e_name))
                    (setq pt3 (cdr (assoc '11 e_list)))
                    (setq ang (round (- (angle pt pt3) (dtr 60)) 4)) ;   
                    (command "_rotate" SS "" pt pause)     ;  
                    (setq e_list (entget e_name))
                    (setq pt3 (cdr (assoc '11 e_list)))    
                    (setq ang (round (- (angle pt pt3) (dtr 60)) 4)) ;    
                )
                (progn
                    (setq e_list (entget e_name))
                    (setq pt3 (cdr (assoc '11 e_list)))
                    (setq ang 0)
                )
            )
            (if (< (setq RG_TYPE (cdr (assoc 'RG_TYPE RG_List))) 2)
                (progn
                    (setq SS (ins_RG_Val RG_List pt ang SS))
                    (setq RG_M_List (ins_RG_TN RG_List pt ang SS))
                    (if (not (null RG_M_List))
                        (progn
                            (setq SS (car RG_M_List))
                            (setq dx (cadr RG_M_List))
                        )
                    )
                    ;(princ (strcat "\n dx: " (rtos dx)))
                    ;(princ "\n ")
                    (setq RG_M_List (ins_bl RG_List ang SS pt3 dx))
                    (if (not (null RG_M_List))
                        (progn
                            (setq SS (car RG_M_List))
                            (setq dx (cadr RG_M_List))
                        )
                    )
                    (setq RG_M_List (ins_T ang SS pt3 dx RG_List))
                    (if (not (null RG_M_List))
                        (progn
                            (setq SS (car RG_M_List))
                            (setq dx (cadr RG_M_List))
                        )
                    )
                )
            )
            (if (= (setq RG_TYPE (cdr (assoc 'RG_TYPE RG_List))) 3)
                (progn
                    (setq SS (ins_RG_Pos RG_List pt ang SS))
                    
                    (setq RG_List_p (GetRough 0 1 1))
                    (if (not (null RG_List_p))
                        (progn
                            (setq pt_p (getpoint "\n   : "))
                            ;   
                            (setq RG_M_List_p (drw_RG RG_List pt_p 0))
                            (setq SS_p (cadr RG_M_List_p))
                            (setq SS_p (ins_RG_Pos RG_List pt_p 0 SS_p))
                            (osnap_off)
                            ($SaveLProp)
                            ($setLTypeDim)
                            (command "_shape" "RG1" (polar pt_p (dtr 30) (* 5 Sc)) sc 0) ;   "="
	                        (osnap_on)
	                        ($RetLProp)
                            (ssadd (entlast) SS_p)
                            (UnBlock pt_p SS_p)

	                        ;     
	                        (setq RG_VAL1 (cdr (assoc 'RG_VAL1 RG_List_p)))
	                        (setq RG_VAL2 (cdr (assoc 'RG_VAL2 RG_List_p)))
	                        (setq RG_PARTYPE (cdr (assoc 'RG_PARTYPE RG_List_p)))
	
    	                    (setq th 4)
    	                    (setq SL1 4)
    	                    
    	                    (if (= RG_PARTYPE 'RZ)
	                            (progn
	                                (setq RG_VAL1 (strcat "Rz" RG_VAL1))
	                                (setq th 4)
	                                (if (not (= RG_VAL2 ""))
	                                    (progn
	                                        (setq RG_VAL2 (strcat "Rz" RG_VAL2))
	                                        (setq th 3.5)
	                                    )
	                                )
	                            )
                                (if (not (= RG_VAL2 ""))
                                    (setq th 3.5)
                                )
	                        )
                            (setq SL2 SL1)
                            (if (> (getSymL RG_VAL1 th sc) SL1)
                                (setq SL1 (getSymL RG_VAL1 th sc))
                                (setq SL1 (+ SL1 (getSymL RG_VAL1 th sc)))
                            )
                            (if (not (null (getSymL RG_VAL2 th sc)))
                                (if (> (getSymL RG_VAL2 th sc) SL2)
                                    (setq SL2 (+ SL2 (getSymL RG_VAL2 th sc)))
                                    (setq SL2 (getSymL RG_VAL2 th sc))
                                )
                            )
                            (if (> SL1 SL2)
                                (setq SL2 SL1)
                                (setq SL1 SL2)
                            )
                            ;***/\*** 
                            ;(Setq pt_p (polar pt_p 0 (+ SL1 (* 8 Sc)))) ;    
                            (Setq pt_p (polar pt_p 0 (+ SL1 (* 10 Sc)))) ;    
                            
                            ;   
                            (setq RG_M_List_p (drw_RG RG_List_p pt_p 0))
                            (setq SS_p (cadr RG_M_List_p))
                            (setq e_name (car RG_M_List_p))
                            (setq e_list (entget e_name))
                            (setq pt3 (cdr (assoc '11 e_list)))
                            (setq SS_p (ins_RG_Val RG_List_p pt_p 0 SS_p))
                            (setq RG_M_List_p (ins_RG_TN RG_List_p pt_p 0 SS_p))
                            (if (not (null RG_M_List_p))
                                (progn
                                    (setq SS_p (car RG_M_List_p))
                                    (setq dx (cadr RG_M_List_p))
                                )
                            )
                            (setq RG_M_List_p (ins_bl RG_List_p 0 SS_p pt3 dx))
                            (if (not (null RG_M_List_p))
                                (progn
                                    (setq SS_p (car RG_M_List_p))
                                    (setq dx (cadr RG_M_List_p))
                                )
                            )
                            (setq RG_M_List_p (ins_T 0 SS_p pt3 dx RG_List_p))
                            (if (not (null RG_M_List_p))
                                (progn
                                    (setq SS_p (car RG_M_List_p))
                                    (setq dx (cadr RG_M_List_p))
                                )
                            )
                            (UnBlock pt_p SS_p)
                        )
                    )
                )
            )
            (if (= (setq RG_TUNSET (cdr (assoc 'RG_TUNSET RG_List))) 1)
                (progn
                    (setq pt_UNSET (polar pt_UNSET 0 (+ (* 1 Sc) dx)))
                    (setq SS (ins_RG_TUNSET pt_UNSET SS ))
                )
            )
            (UnBlock pt SS)
        )
        (progn
            (SetOpt)
            (princ "\n             \n")
            (princ)
            (RetOpt)
        )

    )
    (princ)
)


;=============================================================
(princ "\n     Rough.lsp  ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
